/*
 *       ____   ____      
 *    ___\   \ /   /____  
 *  _/ __ \   Y   // __ \ 
 *  \  ___/\     /\  ___/ 
 *   \___  >\___/  \___  >
 *       \/            \/ 
 *
 *  YaMoR simulator
 *
 *  Cyril Jaquier    
 *  Kevin Drapel
 *
 *  BIRG / LSL - EPFL
 *  http://birg.epfl.ch
 *
 * $Id$
 *
 */
 
#ifndef _BUTTON_H_
#define _BUTTON_H_

#include <string>
#include <vector>

#include <ode/ode.h>
#include <irrlicht.h>

using namespace std;
using namespace irr;

namespace eve { 
	
	// class definition
	class Button {

		public:
			Button();
			~Button();
			void setup(std::string iconFilename, rect<s32> dest);
			void draw(IVideoDriver *driver, int mouseX, int mouseY, bool isOn);
			bool isMouseOver(int mouseX, int mouseY); 
		private:
			video::ITexture* m_texture; 
			rect<s32> m_rect;
 	};	
	
	
} // namespace


#endif
