/*
 *       ____   ____      
 *    ___\   \ /   /____  
 *  _/ __ \   Y   // __ \ 
 *  \  ___/\     /\  ___/ 
 *   \___  >\___/  \___  >
 *       \/            \/ 
 *
 *  YaMoR simulator
 *
 *  Cyril Jaquier    
 *  Kevin Drapel
 *
 *  BIRG / LSL - EPFL
 *  http://birg.epfl.ch
 *
 * $Id$
 *
 */
 
#ifndef _CAMERA_H_
#define _CAMERA_H_

#include <string>
#include <vector>

#include <ode/ode.h>
#include <irrlicht.h>

using namespace std;
using namespace irr;

namespace eve {

	// class definition
	class Camera {
		public:
			Camera();
			~Camera(); 
			
			void move(double amout);
			void strafe(double amount);
			void verticalStrafe(double amount);
			
			void rotate(double angleX, double angleY);
			void mouseDown(int x, int y);
			void mouseUp(); 
			
			bool isDragging() { return m_isDragging; }
			
			irr::core::vector3df m_position;
			irr::core::vector3df m_direction; 
						
			irr::core::vector3df m_up; 
			irr::core::vector3df m_right;
			
		private:
			double m_angleX;
			double m_angleY;
			double m_angleOldX;
			double m_angleOldY;
			
			int m_startX;
			int m_startY; 
			bool m_isDragging;
 	};	
	
	
} // namespace


#endif
