/*
 *       ____   ____      
 *    ___\   \ /   /____  
 *  _/ __ \   Y   // __ \ 
 *  \  ___/\     /\  ___/ 
 *   \___  >\___/  \___  >
 *       \/            \/ 
 *
 *  YaMoR simulator
 *
 *  Cyril Jaquier    
 *  Kevin Drapel
 *
 *  BIRG / LSL - EPFL
 *  http://birg.epfl.ch
 *
 * $Id$
 *
 */
 
#ifndef _GRAPH_H_
#define _GRAPH_H_

#include <string>
#include <vector>

#include <ode/ode.h>
#include <irrlicht.h>

using namespace std;
using namespace irr;

namespace eve {

	class GraphNode; 
	
	// class definition
	class Graph {
		
		vector<GraphNode*> m_nodes;
		
		public:
			Graph();
			~Graph(); 
			void createConnection(GraphNode *node1, GraphNode *node2);
			void scan(GraphNode *parent, GraphNode *node);
			void createNode(int address);
			
			GraphNode  *getNode(int n) { return m_nodes[n];}		
			GraphNode *getNodeFromAddress(int address);
			
			vector<int> m_traversalOrder;
 	};	
	
	
} // namespace


#endif
