/*
 *       ____   ____      
 *    ___\   \ /   /____  
 *  _/ __ \   Y   // __ \ 
 *  \  ___/\     /\  ___/ 
 *   \___  >\___/  \___  >
 *       \/            \/ 
 *
 *  YaMoR simulator
 *
 *  Cyril Jaquier    
 *  Kevin Drapel
 *
 *  BIRG / LSL - EPFL
 *  http://birg.epfl.ch
 *
 * $Id$
 *
 */
 
#ifndef _MESHMANAGER_H_
#define _MESHMANAGER_H_

#include <string>
#include <vector>

#include <ode/ode.h>
#include <irrlicht.h>

#include "mesh.h"

using namespace std;
using namespace irr;

namespace eve {

	class Mesh; 
	
	// class definition
	class MeshManager {
		
		std::vector<Mesh*> m_meshes;
		
		public:
			MeshManager(){}
			
			~MeshManager() {
				for (int n=0;n<m_meshes.size();n++) {
					assert(m_meshes[n]); 
					delete m_meshes[n];	 	
				}
			}
			
			Mesh  *addMesh(std::string filename) {
				Mesh *m = new Mesh(); 
				assert(m); 
				m->loadMesh(filename.c_str()); 
				m->addMesh(); 
				m_meshes.push_back(m); 
				return m; 
			}
			
			std::vector<Mesh*> getMeshes() { return m_meshes; }
			
 	};	
	
	
} // namespace


#endif
