/*
 *       ____   ____      
 *    ___\   \ /   /____  
 *  _/ __ \   Y   // __ \ 
 *  \  ___/\     /\  ___/ 
 *   \___  >\___/  \___  >
 *       \/            \/ 
 *
 *  YaMoR simulator
 *
 *  Cyril Jaquier    
 *  Kevin Drapel
 *
 *  BIRG / LSL - EPFL
 *  http://birg.epfl.ch
 *
 * $Id$
 *
 */
 
#ifndef _QUAKEMAP_H_
#define _QUAKEMAP_H_

#include <string>
#include <vector>
#include <ode/ode.h>
#include <irrlicht.h>

using namespace irr;

namespace eve {
	// class definition
	class QuakeMap {
		public:
			QuakeMap();
			~QuakeMap(); 
			
			void loadData(std::string pk3Filename); 
			void loadBSP(std::string bspFilename); 
			dGeomID createGeom(double quakeScale);
			ISceneNode *getNode() { return m_node; }

			std::vector<triangle3df> *getTriangles() { return (std::vector<triangle3df>*) &m_triangles; }
		protected:	
			std::vector<triangle3df> extractTriangles();
			
			std::vector<triangle3df> m_triangles;
		
			dVector3 *m_vertices;
			int *m_indices;
					
			IAnimatedMesh 	*m_mesh; 
			ISceneNode 		*m_node;
	};

		
} // namespace


#endif
