/*
 *       ____   ____      
 *    ___\   \ /   /____  
 *  _/ __ \   Y   // __ \ 
 *  \  ___/\     /\  ___/ 
 *   \___  >\___/  \___  >
 *       \/            \/ 
 *
 *  YaMoR simulator
 *
 *  Cyril Jaquier    
 *  Kevin Drapel
 *
 *  BIRG / LSL - EPFL
 *  http://birg.epfl.ch
 *
 * $Id$
 *
 */
  
#include "timer.h"
#include "mmgr.h"  

Timer::Timer()
{
	OLD=0.0;
}

Timer::~Timer()
{ 
} 

void Timer::start() {
 
#ifndef _WIN32
	gettimeofday(&first, NULL);	 
#else
	QueryPerformanceCounter(&first);
	QueryPerformanceFrequency(&freq);
#endif
}

/**
 * Update the timer. Portable routine.
 */
float Timer::update() 
{
#ifndef _WIN32

	timeval y;
	gettimeofday(&y, NULL);

	// perform the carry for the later subtraction by updating y.
	if (first.tv_usec < y.tv_usec) {
		int nsec = (y.tv_usec - first.tv_usec) / 1000000 + 1;
		y.tv_usec -= 1000000 * nsec;
		y.tv_sec += nsec;
	}
	if (first.tv_usec - y.tv_usec > 1000000) {
		int nsec = (y.tv_usec - first.tv_usec) / 1000000;
		y.tv_usec += 1000000 * nsec;
		y.tv_sec -= nsec;
	}

	int diffUsec = y.tv_usec - first.tv_usec;
	int diffSec = y.tv_sec - first.tv_sec;

	// if result is negative
	if (first.tv_sec < y.tv_sec) diffUsec = -diffUsec;

	T = diffSec + ((1000000-diffUsec)/1000000.0);
	DT = T - OLD;
	OLD = T;
	return T;
#else

	QueryPerformanceCounter(&cur);
	T = float(cur.QuadPart - first.QuadPart) / double(freq.QuadPart);
	DT = T - OLD;
	OLD = T;
	return T;

#endif
}

