/*
 *       ____   ____      
 *    ___\   \ /   /____  
 *  _/ __ \   Y   // __ \ 
 *  \  ___/\     /\  ___/ 
 *   \___  >\___/  \___  >
 *       \/            \/ 
 *
 *  YaMoR simulator
 *
 *  Cyril Jaquier    
 *  Kevin Drapel
 *
 *  BIRG / LSL - EPFL
 *  http://birg.epfl.ch
 *
 * $Id$
 *
 */

#ifndef _TIMER_H_
#define _TIMER_H_

#ifdef _WIN32
#include <windows.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>

class Timer
{
public:
	Timer();
	~Timer();

	void start();
	float update();

#ifndef _WIN32
	timeval first;
#else
	LARGE_INTEGER first;	
	LARGE_INTEGER freq;	
	LARGE_INTEGER cur;	
#endif

	float T;
	float DT;

private:
	float OLD;

};

#endif
