/*
 *       ____   ____      
 *    ___\   \ /   /____  
 *  _/ __ \   Y   // __ \ 
 *  \  ___/\     /\  ___/ 
 *   \___  >\___/  \___  >
 *       \/            \/ 
 *
 *  YaMoR simulator
 *
 *  Cyril Jaquier    
 *  Kevin Drapel
 *
 *  BIRG / LSL - EPFL
 *  http://birg.epfl.ch
 *
 * $Id$
 *
 */
 
#ifndef _UTILS_H_
#define _UTILS_H_

#include <ode/ode.h>
#include <irrlicht.h>

using namespace irr;
using namespace core;
using namespace scene;

#define frand()   ((float)rand()*(1.0f/(float)RAND_MAX))

namespace eve {
	
	class Utils {
		public:
			static void QuaternionToEuler(const dQuaternion quaternion,irr::core::vector3df &euler);
			static void EulerToQuaternion(const irr::core::vector3df &euler, dQuaternion quaternion);
			static void DebugVector3df(irr::core::vector3df vec, char *name="vec"); 
			static bool isSameSide(vector3df p1, vector3df p2, vector3df pA, vector3df pB);
			static bool isPointInsideTriangle(vector3df myPoint, vector3df pA, vector3df pB, vector3df pC); 
			static bool isTriangleInsideSphere(vector3df center, double radius, triangle3df t);
			static float getDistanceToLine(vector3df start, vector3df end, vector3df p);
		protected:
			Utils() {}
			~Utils() {} 
	};	
	
} // namespace

#endif
