/*
 *       ____   ____      
 *    ___\   \ /   /____  
 *  _/ __ \   Y   // __ \ 
 *  \  ___/\     /\  ___/ 
 *   \___  >\___/  \___  >
 *       \/            \/ 
 *
 *  YaMoR simulator
 *
 *  Cyril Jaquier    
 *  Kevin Drapel
 *
 *  BIRG / LSL - EPFL
 *  http://birg.epfl.ch
 *
 * $Id$
 *
 */
 
#ifndef _XMLREADER_H_
#define _XMLREADER_H_

#include <string>
#include <map>
#include <ode/ode.h>
#include <irrlicht.h>
#include <tinyxml.h>

using namespace irr;

namespace eve {
	
	class QuakeMap;
	class Robot; 
	
	// class definition
	class XMLReader {
		public:
			XMLReader();
			~XMLReader(); 
			TiXmlDocument *openFile(std::string filename);
			Robot* readRobotDescription(std::string filename, vector3df robotPos, vector3df robotRot, double massModule, double massLeveler); 
			void readEveOdeConfig(std::string filename, OdeGlobalParameters &odeParam); 
			void readEveIrrlichtConfig(std::string filename, int &width, int &height, int &fullscreen);
			void readEveConfigSetupWorld(std::string filename, QuakeMap **ptrQuake, vector3df &robotPos,
										 vector3df &robotRot, int &serverPort, double &massModule, double &massLeveler, std::string &robotXMLName);
	
			int getIntAttribute(TiXmlElement *node, std::string name);
			double getDoubleAttribute(TiXmlElement *node, std::string name);
			const char *getStringAttribute(TiXmlElement *node, std::string name); 
			
			vector3df getVectorAttribute(TiXmlElement *node);
		protected:
 	};	
	
} // namespace


#endif
