#ifndef _XMLRPC_H_
#define _XMLRPC_H_

#include <string>
#include <map>
#include <ode/ode.h>
#include <irrlicht.h>
#include <tinyxml.h>

#include <pthread.h>
#include <xmlrpc.h>
#include <xmlrpc_server.h>
#include <xmlrpc_server_abyss.h>
#include <string>

using namespace std; 

namespace eve {

class Robot; 

class XMLRpc
{
	public:
		XMLRpc() {}
		~XMLRpc() {}
		static xmlrpc_value *ping(xmlrpc_env *const env, xmlrpc_value *const param_array, void *const user_data); 
		static xmlrpc_value *setServoPosition(xmlrpc_env *const env, xmlrpc_value *const param_array, void *const user_data);
		static xmlrpc_value *setServoIntPosition(xmlrpc_env *const env, xmlrpc_value *const param_array, void *const user_data);
		static xmlrpc_value *testArray(xmlrpc_env *const env, xmlrpc_value *const param_array, void *const user_data);
		static xmlrpc_value *setAllServos(xmlrpc_env *const env, xmlrpc_value *const param_array, void *const user_data);
		
		static void serverSetup(int port, std::string logfile);
		static void *serverThreadFunc(void *ptr);

		
		static Robot *robot; 
		static xmlrpc_server_abyss_parms serverparm;
		static xmlrpc_registry *registryP;
		static xmlrpc_env env;	
};

} // namespace

#endif 
